Signed-off-by: Eyvind Bernhardsen <eyvind.bernhardsen@gmail.com>
---
t/t0025-auto-eol.sh | 180 +++++++++++++++++++++++++++++++++++++++++++++++++++
1 files changed, 180 insertions(+), 0 deletions(-)
create mode 100755 t/t0025-auto-eol.sh
diff --git a/t/t0025-auto-eol.sh b/t/t0025-auto-eol.sh
new file mode 100755
index 0000000..5acee2d
--- /dev/null
+++ b/t/t0025-auto-eol.sh
@@ -0,0 +1,180 @@
+#!/bin/sh
+
+test_description='CRLF conversion'
+
+. ./test-lib.sh
+
+has_cr() {
+ tr '\015' Q <"$1" | grep Q >/dev/null
+}
+
+test_expect_success setup '
+
+ git config core.autocrlf false &&
+
+ for w in Hello world how are you; do echo $w; done >one &&
+ for w in I am very very fine thank you; do echo ${w}Q; done | q_to_cr >two &&
+ git add . &&
+
+ git commit -m initial &&
+
+ one=`git rev-parse HEAD:one` &&
+ two=`git rev-parse HEAD:two` &&
+
+ for w in Some extra lines here; do echo $w; done >>one &&
+ git diff >patch.file &&
+ patched=`git hash-object --stdin <one` &&
+ git read-tree --reset -u HEAD &&
+
+ echo happy.
+'
+
+test_expect_success 'default settings cause no changes' '
+
+ rm -f .gitattributes tmp one two &&
+ git read-tree --reset -u HEAD &&
+
+ if has_cr one || ! has_cr two
+ then
+ echo "Eh? $f"
+ false
+ fi &&
+ onediff=`git diff one` &&
+ twodiff=`git diff two` &&
+ test -z "$onediff" -a -z "$twodiff"
+'
+
+test_expect_success 'no auto-eol, explicit eolstyle=native causes no changes' '
+
+ rm -f .gitattributes tmp one two &&
+ git config core.eolstyle native &&
+ git read-tree --reset -u HEAD &&
+
+ if has_cr one || ! has_cr two
+ then
+ echo "Eh? $f"
+ false
+ fi &&
+ onediff=`git diff one` &&
+ twodiff=`git diff two` &&
+ test -z "$onediff" -a -z "$twodiff"
+'
+
+test_expect_failure 'auto-eol=true, eolStyle=crlf <=> autocrlf=true' '
+
+ rm -f .gitattributes tmp one two &&
+ git config core.autocrlf false &&
+ git config core.eolstyle crlf &&
+ echo "* auto-eol" > .gitattributes &&
+ git read-tree --reset -u HEAD &&
+ unset missing_cr &&
+
+ for f in one two
+ do
+ if ! has_cr "$f"
+ then
+ echo "Eh? $f"
+ missing_cr=1
+ break
+ fi
+ done &&
+ test -z "$missing_cr"
+'
+
+test_expect_failure 'auto-eol=true, eolStyle=lf <=> autocrlf=input' '
+
+ rm -f .gitattributes tmp one two &&
+ git config core.autocrlf false &&
+ git config core.eolstyle lf &&
+ echo "* auto-eol" > .gitattributes &&
+ git read-tree --reset -u HEAD &&
+
+ if has_cr one || ! has_cr two
+ then
+ echo "Eh? $f"
+ false
+ fi &&
+ onediff=`git diff one` &&
+ twodiff=`git diff two` &&
+ test -z "$onediff" -a -n "$twodiff"
+'
+
+test_expect_success 'auto-eol=true, eolStyle=false <=> autocrlf=false' '
+
+ rm -f .gitattributes tmp one two &&
+ git config core.autocrlf false &&
+ git config core.eolstyle false &&
+ echo "* auto-eol" > .gitattributes &&
+ git read-tree --reset -u HEAD &&
+
+ if has_cr one || ! has_cr two
+ then
+ echo "Eh? $f"
+ false
+ fi
+ onediff=`git diff one` &&
+ twodiff=`git diff two` &&
+ test -z "$onediff" -a -z "$twodiff"
+'
+
+test_expect_success 'autocrlf=true overrides auto-eol=true, eolStyle=lf' '
+
+ rm -f .gitattributes tmp one two &&
+ git config core.autocrlf true &&
+ git config core.eolstyle lf &&
+ echo "* auto-eol" > .gitattributes &&
+ git read-tree --reset -u HEAD &&
+ unset missing_cr &&
+
+ for f in one two
+ do
+ if ! has_cr "$f"
+ then
+ echo "Eh? $f"
+ missing_cr=1
+ break
+ fi
+ done &&
+ test -z "$missing_cr"
+'
+
+test_expect_success 'autocrlf=input overrides auto-eol=true, eolStyle=crlf' '
+
+ rm -f .gitattributes tmp one two &&
+ git config core.autocrlf input &&
+ git config core.eolstyle crlf &&
+ echo "* auto-eol" > .gitattributes &&
+ git read-tree --reset -u HEAD &&
+
+ if has_cr one || ! has_cr two
+ then
+ echo "Eh? $f"
+ false
+ fi &&
+ onediff=`git diff one` &&
+ twodiff=`git diff two` &&
+ test -z "$onediff" -a -n "$twodiff"
+'
+
+test_expect_success 'autocrlf=true overrides auto-eol=true, eolStyle=false' '
+
+ rm -f .gitattributes tmp one two &&
+ git config core.autocrlf true &&
+ git config core.eolstyle false &&
+ echo "* auto-eol" > .gitattributes &&
+ git read-tree --reset -u HEAD &&
+ unset missing_cr &&
+
+ for f in one two
+ do
+ if ! has_cr "$f"
+ then
+ echo "Eh? $f"
+ missing_cr=1
+ break
+ fi
+ done &&
+ test -z "$missing_cr"
+'
+
+test_done
--
1.7.1.3.gb95c9
--
To unsubscribe from this list: send the line "unsubscribe git" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at http://vger.kernel.org/majordomo-info.html